%define kdeprefix /opt/kde
%define version 1.1.1
%define kderelease 2
%define sourcedir stable/1.1.1/distribution/tar/generic/source
%define tag -1.1.1
%define topdirtag -1.1.1
Serial: 3

%define target RedHat 5.1 or 5.2 systems
%define compiler egcs
%define rhseries rh5x
%define redhat redhat-release >= 5.1
%define qtrequired  qt >= 1.42 qt-egcs-10x

%define ktalk ktalk-0.2.7
%define kdename kdenetwork 
%define topdir %{kdename}%{topdirtag}
Name: %{kdename}
Summary: K Desktop Environment - Network Applications
Version: %{version}
Release: %{kderelease}%{rhseries}
URL: http://www.kde.org
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{kdename}%{tag}.tar.gz
Source1: ftp://ftp.kde.org/pub/kde/stable/1.1/apps/network/%{ktalk}.tar.gz
Patch: kdenetwork-%{version}-ktalkd.patch
Patch1: kdenetwork-1.1.1-kmail.patch
Group: X11/KDE/Networking
BuildRoot: /var/tmp/%{kdename}-buildroot
Copyright: GPL
Requires: %{qtrequired} %{redhat} kdebase-%{rhseries}
Packager: KDE Packaging Team <redhat-rpms@kde.org>
Distribution: KDE
Vendor: The KDE Team
Prefix: %{kdeprefix}
%define packages tools mail ppp news irc talk
%define tools karchie kbiff korn kfinger knu 
%define mail kmail 
%define ppp kppp 
%define news krn 
%define irc ksirc 
%define talk ktalkd
%define subdirs %tools %mail %ppp %news %irc %talk

%description 
Network applications for the K Desktop Environment. 

Includes: karchie (ftp archive searcher); kbiff (mail delivery notification)
kfinger ("finger" utility); kmail (mail client); knu (network utilities);
korn  (mailbox monitor tool); kppp (easy PPP connection configuration);
krn (news reader); ktalkd (talk daemon); ksirc (irc client).

The talk client %{ktalk} is also added to this package.

%package tools
Obsoletes: kdenetwork 
Summary: K Desktop Environment - Network Applications - various tools
Group: X11/KDE/Networking
Copyright: GPL
Prefix: %{kdeprefix}
%description tools
This package supplies some network utilities from the "kdenetwork" collection 
of KDE applications:
-- karchie, graphical interface for searching ftp sites on the using "archie".
-- kbiff, a mail delivery notification application.
-- korn, a mailbox monitoring tool.
-- kfinger, a graphical interface to the "finger" utility.
-- knu, a graphical interface to network utilities such as traceroute.

%package mail
Obsoletes: kdenetwork 
Summary: K Desktop Environment - Network Applications - kmail
Group: X11/KDE/Networking
Copyright: GPL
Prefix: %{kdeprefix}
%description mail
This is the application "kmail" from the "kdenetwork" collection of KDE 
applications. It is a fully-featured mail client for reading, sending, and 
managing electronic mail.

This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%package ppp
Obsoletes: kdenetwork 
Summary: K Desktop Environment - Network Applications - kppp
Group: X11/KDE/Networking
Copyright: GPL
Prefix: %{kdeprefix}
%description ppp
This is the application "kppp" from the "kdenetwork" collection of KDE 
applications. It provides a graphical interface for setting up and managing 
ppp internet connections over telephone lines, with using "rules" customized 
for the telephone systems of many different countries.

This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%package news
Obsoletes: kdenetwork 
Summary: K Desktop Environment - Network Applications - krn
Group: X11/KDE/Networking
Copyright: GPL
Prefix: %{kdeprefix}
%description news
This is the application "krn" from the "kdenetwork" collection of KDE 
applications. It is a news reader application for use with Internet newsgroups.

This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%package irc
Obsoletes: kdenetwork 
Summary: K Desktop Environment - Network Applications - ksirc
Group: X11/KDE/Networking
Copyright: GPL
Prefix: %{kdeprefix}
Prereq: /sbin/ldconfig
%description irc
This is the application "ksirc" from the "kdenetwork" collection of KDE 
applications. It is a client for Internet Relay Chat.

This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%package talk
Obsoletes: kdenetwork 
Obsoletes: ktalk
Summary: K Desktop Environment - Network Applications - ktalkd
Group: X11/KDE/Networking
Copyright: GPL
Prefix: %{kdeprefix}
%description talk
This package contains the application "ktalkd" from the "kdenetwork" 
collection of KDE  applications, which is a "daemon" for managing direct 
communication over a network with the keyboard using the "talk" protocol,

It also supplies  the application %{ktalk}, which  is an intuitive 
talk client, including addressbook, word wrap file transfer, ping, full name, 
etc. (ktalk is not yet part of the kdenetwork collection, but is  an "extra"
KDE application added by the rpm packagers).

This package is intended for %{target}.
It will be installed by default in %{kdeprefix}, but is relocatable to install
under e.g., /usr/kde, using "rpm --prefix /usr/kde ..."

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n %{topdir}
%patch -p1
#kmail security fix patch
%patch1 -p1

%setup -q  -T  -n %{ktalk} -b 1





%build
cd $RPM_BUILD_DIR/%{topdir}
export KDEDIR=%{kdeprefix}
CC=%{compiler} ./configure  --prefix=%{kdeprefix} --with-install-root=$RPM_BUILD_ROOT
make 
# compile ktalk
cd $RPM_BUILD_DIR//%{ktalk} 
CC=%{compiler} ./configure --prefix=%{kdeprefix} 
make 


%install

cd $RPM_BUILD_DIR/%{topdir}/po
rm -rf $RPM_BUILD_ROOT/*
make prefix=$RPM_BUILD_ROOT%{kdeprefix} install-strip
rm -rf $RPM_BUILD_DIR/%{kdename}-po
mkdir $RPM_BUILD_DIR/%{kdename}-po
cp -a $RPM_BUILD_ROOT/* $RPM_BUILD_DIR/%{kdename}-po

#ksirc doesnt build with gcc-2.7.2.3 (rh42) 
for subdir in %{subdirs} ; do
	rm -rf $RPM_BUILD_ROOT/*
	cd $RPM_BUILD_DIR/%{kdename}-po
        find . -name "$subdir*" | cpio -dpv $RPM_BUILD_ROOT       
        find $RPM_BUILD_ROOT -type d -exec chmod 0755 {} ';'      
	cd $RPM_BUILD_DIR/%{topdir}/$subdir
        if ! [ "%{rhseries}" = "rh42" ] || ! [ "$subdir" = "ksirc" ] ; then       
		make prefix=$RPM_BUILD_ROOT%{kdeprefix} install-strip
	fi
# add the ktalk app to the talk subpackage:
        if [ "$subdir" = "ktalkd" ] ; then
		cd $RPM_BUILD_DIR/%{ktalk}
		make prefix=$RPM_BUILD_ROOT%{kdeprefix} install-strip
        fi
# remove the bad PWS kdelnk in ksirc (quick fix)
	if [ "$subdir" = "ksirc" ] ; then
		rm -f $RPM_BUILD_ROOT%{kdeprefix}/share/applnk/Internet/pws.kdelnk
	fi

	cd $RPM_BUILD_ROOT
	tar -cvf $RPM_BUILD_DIR/$subdir.tar .%{kdeprefix}
done

cd $RPM_BUILD_ROOT
for package in %{packages} ; do
	rm -rf $RPM_BUILD_ROOT/*
        pkgdirs=""
	if   [ "$package" = "tools" ] ; then pkgdirs="%{tools}"
	elif [ "$package" = "mail" ] ; then pkgdirs="%{mail}"
	elif [ "$package" = "news" ] ; then pkgdirs="%{news}"
	elif [ "$package" = "ppp" ] ; then pkgdirs="%{ppp}"
	elif [ "$package" = "irc" ] ; then pkgdirs="%{irc}"
	elif [ "$package" = "talk" ] ; then pkgdirs="%{talk}"
	fi
	for subdir in $pkgdirs ; do
		tar -xvf $RPM_BUILD_DIR/$subdir.tar
		rm $RPM_BUILD_DIR/$subdir.tar
	done

	tar -cvf $RPM_BUILD_DIR/$package.pkg.tar .
	find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
		$RPM_BUILD_DIR/file.list.%{kdename}.$package

	find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
		-e '/\/config\//s|^|%config|' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}.$package

	find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}.$package
done

#ksirc doesnt build with gcc-2.7.2.3 (rh42) 
#this will make the kdepackage-irc package empty
if [ "%{rhseries}" = "rh42" ] ; then
	echo " " > $RPM_BUILD_DIR/file.list.%{kdename}.irc
fi


cd $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT/*
for package in %{packages} ; do
	tar -xvf $RPM_BUILD_DIR/$package.pkg.tar
done

# fix library permisions if ksirc was built
if [ -d $RPM_BUILD_ROOT%{kdeprefix}/lib ] ; then
	chmod a+x $RPM_BUILD_ROOT%{kdeprefix}/lib/*
	chmod a+x $RPM_BUILD_ROOT%{kdeprefix}/lib/ksirc/*
fi

# fix suid root bit on kppp
cat $RPM_BUILD_DIR/file.list.%{kdename}.ppp > $RPM_BUILD_DIR/temp
sed -e '/\/bin\/kppp$/s/attr(-/attr(4755/' $RPM_BUILD_DIR/temp > $RPM_BUILD_DIR/file.list.%{kdename}.ppp 
rm -f $RPM_BUILD_DIR/temp


%post irc
/sbin/ldconfig

%postun irc
/sbin/ldconfig




%post talk
# modify /etc/inetd.conf for ktalkd
cp -af /etc/inetd.conf /etc/inetd.conf.kdesave
grep -v "bin/ktalkd"  /etc/inetd.conf | grep -v "bin/kotalkd" > /etc/inetd.conf_temp.1
sed -e "/in.talkd/s/^talk/#KDE:talk/" -e "/in.ntalkd/s/^ntalk/#KDE:ntalk/" /etc/inetd.conf_temp.1 > /etc/inetd.conf_temp.2
sed -e '/in.talkd/s;$;\
talk    dgram   udp     wait    root    \/usr\/sbin\/tcpd  KDEDIR/bin/kotalkd;' -e '/in.ntalkd/s;$;\
ntalk   dgram   udp     wait    root    \/usr\/sbin\/tcpd  KDEDIR/bin/ktalkd;' /etc/inetd.conf_temp.2 > /etc/inetd.conf_temp.1
sed -e "s^KDEDIR^$RPM_INSTALL_PREFIX^g" /etc/inetd.conf_temp.1> /etc/inetd.conf
rm -f /etc/inetd.conf_temp.1 /etc/inetd.conf_temp.2
/usr/bin/killall -HUP inetd



%postun talk
# restore previous /etc/inet.conf talk entries
if [ "$1" = "0" ] ; then  
   cp -af /etc/inetd.conf /etc/inetd.conf.kdesave
   grep -v "bin/ktalkd"  /etc/inetd.conf | grep -v "bin/kotalkd" > /etc/inetd.conf_temp
   sed -e "s/^#KDE://g" /etc/inetd.conf_temp > /etc/inetd.conf
   rm -f /etc/inetd.conf_temp
fi







%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/%{kdename}-po
for package in %{packages} ; do
	rm -f $RPM_BUILD_DIR/file.list.%{kdename}.$package
	rm -f $RPM_BUILD_DIR/$package.pkg.tar
done

%files tools -f ../file.list.%{kdename}.tools
%files mail -f ../file.list.%{kdename}.mail
%files ppp -f ../file.list.%{kdename}.ppp
%files news -f ../file.list.%{kdename}.news
%files irc -f ../file.list.%{kdename}.irc
%files talk -f ../file.list.%{kdename}.talk

%changelog
* Thu Jun 10 1999 <duncan@kde.org>
- applied kmail security fix patch

* Sat Apr 18 1999 <duncan@kde.org>
- integrated the ktalk client (v-0.2.7) into the
- talk subpackage
 
* Sat Feb 13 1999 <duncan@kde.org>
- files in KDEDIR/share/applnk no longer treated as %config files
- fix bad /opt/kde directory permissions bug 

* Mon Feb 8 1999 <duncan@kde.org>
- new rpm packaging for KDE-1.1
- relocatable rpms
- individual apps in subpackages




